﻿using Syncfusion.SfGauge.XForms;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Xamarin.Forms;

namespace CircularGauge_Opacity
{
   public class Circular_Gauge : ContentPage
    {
       SfCircularGauge circularGauge;
        Scale scale;
        NeedlePointer needlePointer1;
        NeedlePointer needlePointer2;
        NeedlePointer needlePointer3;
        
        RangePointer rangePointer;
        TickSettings major;
        Grid grid = new Grid();

        public Circular_Gauge()
        {
            StackLayout _layout = new StackLayout();
            _layout.Orientation = StackOrientation.Vertical;
            _layout.SizeChanged += _layout_SizeChanged;    
            _layout.VerticalOptions = LayoutOptions.FillAndExpand;

            StackLayout stack = new StackLayout();
            stack.BackgroundColor = Color.White;
            stack.Padding = 10;
            Label pointer = new Label();
            pointer.Text = "Pointer Value";
            
             if (Device.OS == TargetPlatform.Android)
            {
                pointer.FontSize = 15;
            }
            

            pointer.TextColor = Color.Black;
            pointer.FontAttributes = FontAttributes.Bold;

            Xamarin.Forms.Slider pointerSlider = new Xamarin.Forms.Slider();
            pointerSlider.Maximum = 100;
            pointerSlider.Value = 10;
            pointerSlider.ValueChanged += pointerSlider_ValueChanged;
            stack.Children.Add(pointer);
            stack.Children.Add(pointerSlider);
            grid.Children.Add(stack);
            _layout.Children.Add(getCircularGauge());
            grid.Children.Add(_layout);
            this.Content = grid;
            this.Content.BackgroundColor = Color.White;
           
        }

        void _layout_SizeChanged(object sender, EventArgs e)
        {
            circularGauge.WidthRequest = 330;
            circularGauge.HeightRequest = 330;
        }

        SfCircularGauge getCircularGauge()
        {
            if (this.Content == null)
            {
                circularGauge = new SfCircularGauge();
                ObservableCollection<Scale> scales = new ObservableCollection<Scale>();
                circularGauge.VerticalOptions = LayoutOptions.CenterAndExpand;
                //Scales
                scale = new Scale();
                scale.StartValue = 0;
                scale.EndValue = 100;
                scale.Interval = 10;
                scale.StartAngle = 135;
                scale.SweepAngle = 270;
                scale.RimThickness = 20;
                scale.RimColor = Color.Gray;
                scale.LabelColor = Color.Gray;
                scale.LabelOffset = 0.1;
                scale.MinorTicksPerInterval = 0;
                List<Pointer> pointers = new List<Pointer>();

                needlePointer1 = new NeedlePointer();
                needlePointer1.Value = 10;
                Color firstNeedlePointerColor = Color.Blue;
                // A from RGBA denotes alpha(opacity) value for the color, it varies from 0 to 1
                needlePointer1.Color = SetTransparency(0.2, Color.Blue);
                needlePointer1.KnobRadius = 20;
                needlePointer1.KnobColor = Color.FromHex("#2bbfb8");
                needlePointer1.Thickness = 5;
                needlePointer1.LengthFactor = 0.8;
                needlePointer1.Type = PointerType.Bar;

                needlePointer2 = new NeedlePointer();
                needlePointer2.Value = 20;
                needlePointer2.Color = SetTransparency(0.3, Color.Blue);
                needlePointer2.KnobRadius = 20;
                needlePointer2.KnobColor = Color.FromHex("#2bbfb8");
                needlePointer2.Thickness = 5;
                needlePointer2.LengthFactor = 0.8;
                needlePointer2.Type = PointerType.Bar;

                needlePointer3 = new NeedlePointer();
                needlePointer3.Value = 30;
                needlePointer3.Color = SetTransparency(0.5, Color.Blue);
                needlePointer3.KnobRadius = 20;
                needlePointer3.KnobColor = Color.FromHex("#2bbfb8");
                needlePointer3.Thickness = 5;
                needlePointer3.LengthFactor = 0.8;
                needlePointer3.Type = PointerType.Bar;

                rangePointer = new RangePointer();
                rangePointer.Value = 10;
                rangePointer.Color = SetTransparency(0.3, Color.FromHex("#2bbfb8"));
                rangePointer.Thickness = 20;
               
                pointers.Add(needlePointer1);
                pointers.Add(needlePointer2);
                pointers.Add(needlePointer3);
                
                
                pointers.Add(rangePointer);

                TickSettings minor = new TickSettings();
                minor.Length = 4;
                minor.Color = Color.FromHex("#444444");
                minor.Thickness = 3;
                scale.MinorTickSettings = minor;

                major = new TickSettings();
                major.Length = 12;
                major.Color = Color.FromHex("#444444");
                major.Thickness = 3;
                major.Offset = Device.OnPlatform(0.05, 0.1,0.3);
                scale.MajorTickSettings = major;
                scale.Pointers = pointers;
                scales.Add(scale);
                circularGauge.Scales = scales;

                Header header = new Header();
                header.Text = "Speedmeter";
                header.TextSize = 20;
                header.Position = Device.OnPlatform(iOS: new Point(.3, .7), Android: new Point(0.38, 0.7), WinPhone: new Point(0.38, 0.7));
                header.ForegroundColor = Color.Gray;
                circularGauge.Headers.Add(header);
            }
            return circularGauge;
        }

        void pointerSlider_ValueChanged(object sender, ValueChangedEventArgs e)
        {
            needlePointer1.Value = e.NewValue;
            rangePointer.Value = e.NewValue;
            rangePointer.Color = SetTransparency(e.NewValue / 100, Color.FromHex("#2bbfb8"));
            needlePointer1.Color = SetTransparency((e.NewValue / 100), Color.Blue);
            needlePointer2.Value = e.NewValue + 10;
            needlePointer2.Color = SetTransparency(e.NewValue/ 100, Color.Blue);
            needlePointer3.Value = e.NewValue + 20;
            needlePointer3.Color = SetTransparency(e.NewValue/ 100, Color.Blue);
        }
        Color SetTransparency(double A, Color color)
        {
            return Color.FromRgba(color.R, color.G, color.B, A);
        }
    }
}
